{
  "openapi": "3.0.0",
  "servers": [
    {
      "url": "https://{instance_id}.{region}.secrets-manager.appdomain.cloud",
      "variables": {
        "instance_id": {
          "default": "provide-here-your-smgr-instanceuuid",
          "description": "The Secrets Manager Instance ID assigned by the service provider"
        },
        "region": {
          "default": "us-south",
          "description": "The region where you provisioned your Secrets Manager Instance. Available values: us-south, us-east, au-syd, jp-osa, jp-tok, eu-de, eu-gb, eu-es, ca-tor, ca-mon, br-sao, in-che"
        }
      }
    },
    {
      "url": "https://{instance_id}.{region}.secrets-manager.test.appdomain.cloud",
      "variables": {
        "instance_id": {
          "default": "provide-here-your-smgr-instanceuuid",
          "description": "The Secrets Manager Instance ID assigned by the service provider"
        },
        "region": {
          "default": "us-south",
          "description": "The region where you provisioned your Secrets Manager Instance. Available values: us-south, eu-gb"
        }
      }
    },
    {
      "url": "/"
    }
  ],
  "info": {
    "title": "IBM Cloud Secrets Manager API",
    "x-alternate-name": "secrets-manager",
    "version": "2.0.0",
    "x-ibm-name": "secrets-manager",
    "description": "## Introduction\n\nWith IBM Cloud® Secrets Manager, you can create, lease, and centrally manage secrets that are used in IBM Cloud services or your custom-built applications. Secrets are stored in a dedicated instance of Secrets Manager that is built on open source HashiCorp Vault.\n\nSDKs for Java, Node, Python, and Go are available to make it easier to programmatically access the API from your code. The client libraries that are provided by the SDKs implement best practices for using the API and reduce the amount of code that you need to write. The tab for each language includes code examples that demonstrate how to use the client libraries. \n\nFor more information about using the SDKs, see the [IBM Cloud SDK Common project](https://github.com/IBM/ibm-cloud-sdk-common) on GitHub. For more information about getting started with Secrets Manager, check out the [docs](https://cloud.ibm.com/docs/secrets-manager).\n\nInstalling the Java SDK\n\nMaven\n\n```xml\n<dependency>\n    <groupId>com.ibm.cloud</groupId>\n    <artifactId>secrets-manager-sdk</artifactId>\n    <version>${version}</version>\n</dependency>\n```\n\nGradle\n\n```java\ncompile 'com.ibm.cloud:secrets-manager-sdk:${version}'\n```\n\nReplace `{version}` in these examples with the release version.\n\nView on GitHub\n\nhttps://github.com/IBM/secrets-manager-java-sdk\n\nInstalling the Python SDK\n\n```bash\npip install --upgrade \"ibm-secrets-manager-sdk\"\n```\n\nView on GitHub\n\nhttps://github.com/IBM/secrets-manager-python-sdk\n\nInstalling the Go SDK\n\nGo modules (recommended): Add the following import in your code, and then run `go build` or `go mod tidy`\n\n```go\nimport (\n   sm \"github.com/IBM/secrets-manager-go-sdk/v2/secretsmanagerv2\"\n)\n```\n\nGo get\n\n```bash\ngo get -u github.com/IBM/secrets-manager-go-sdk/v2\n```\n\nView on GitHub\n\nhttps://github.com/IBM/secrets-manager-go-sdk\n\nInstalling the Node SDK\n\n```bash\nnpm install @ibm-cloud/secrets-manager\n```\n\nView on GitHub\n\nhttps://github.com/IBM/secrets-manager-node-sdk\n\n## Endpoint URLs\n\nSecrets Manager supports instance-specific endpoint URLs that you can use to interact with the service over [public or private service endpoints](https://cloud.ibm.com/docs/secrets-manager?topic=secrets-manager-endpoints#service-endpoints). To make requests to the API, you supply the instance ID that is unique to your Secrets Manager service instance.\n\nYou can copy your endpoint URL from the **Endpoints** page in the Secrets Manager service dashboard.\n\n**Endpoint URLs by location**\n\n- Chennai: `https://{instance_ID}.in-che.secrets-manager.appdomain.cloud` \n- Dallas: `https://{instance_ID}.us-south.secrets-manager.appdomain.cloud`\n- Frankfurt: `https://{instance_ID}.eu-de.secrets-manager.appdomain.cloud`\n- London: `https://{instance_ID}.eu-gb.secrets-manager.appdomain.cloud`\n- Madrid: `https://{instance_ID}.eu-es.secrets-manager.appdomain.cloud`\n- Osaka: `https://{instance_ID}.jp-osa.secrets-manager.appdomain.cloud`\n- Sao Paulo: `https://{instance_ID}.br-sao.secrets-manager.appdomain.cloud`\n- Sydney: `https://{instance_ID}.au-syd.secrets-manager.appdomain.cloud`\n- Tokyo: `https://{instance_ID}.jp-tok.secrets-manager.appdomain.cloud`\n- Toronto: `https://{instance_ID}.ca-tor.secrets-manager.appdomain.cloud`\n- Montreal: `https://{instance_ID}.ca-mon.secrets-manager.appdomain.cloud`\n- Washington DC: `https://{instance_ID}.us-east.secrets-manager.appdomain.cloud`\n\nSecrets Manager supports instance-specific endpoint URLs that you can use to interact with the service over [public or private service endpoints](https://cloud.ibm.com/docs/secrets-manager?topic=secrets-manager-endpoints#service-endpoints). To target your Secrets Manager service instance by using the Java SDK, use the `setServiceUrl()` method. You can copy your endpoint URL from the **Endpoints** page in the Secrets Manager service dashboard.\n\n**Endpoint URLs by location**\n\n- Chennai - Airtel: `https://{instance_ID}.in-che.secrets-manager.appdomain.cloud` \n- Dallas: `https://{instance_ID}.us-south.secrets-manager.appdomain.cloud`\n- Frankfurt: `https://{instance_ID}.eu-de.secrets-manager.appdomain.cloud`\n- London: `https://{instance_ID}.eu-gb.secrets-manager.appdomain.cloud`\n- Madrid: `https://{instance_ID}.eu-es.secrets-manager.appdomain.cloud`\n- Osaka: `https://{instance_ID}.jp-osa.secrets-manager.appdomain.cloud`\n- Sao Paulo: `https://{instance_ID}.br-sao.secrets-manager.appdomain.cloud`\n- Sydney: `https://{instance_ID}.au-syd.secrets-manager.appdomain.cloud`\n- Tokyo: `https://{instance_ID}.jp-tok.secrets-manager.appdomain.cloud`\n- Toronto: `https://{instance_ID}.ca-tor.secrets-manager.appdomain.cloud`\n- Montreal: `https://{instance_ID}.ca-mon.secrets-manager.appdomain.cloud`\n- Washington DC: `https://{instance_ID}.us-east.secrets-manager.appdomain.cloud`\n\nSecrets Manager supports instance-specific endpoint URLs that you can use to interact with the service over [public or private service endpoints](https://cloud.ibm.com/docs/secrets-manager?topic=secrets-manager-endpoints#service-endpoints). To target your Secrets Manager service instance by using the Node.js SDK, use the `serviceUrl` parameter. You can copy your endpoint URL from the **Endpoints** page in the Secrets Manager service dashboard.\n\n**Endpoint URLs by location**\n\n- Chennai - Airtel: `https://{instance_ID}.in-che.secrets-manager.appdomain.cloud` \n- Dallas: `https://{instance_ID}.us-south.secrets-manager.appdomain.cloud`\n- Frankfurt: `https://{instance_ID}.eu-de.secrets-manager.appdomain.cloud`\n- London: `https://{instance_ID}.eu-gb.secrets-manager.appdomain.cloud`\n- Madrid: `https://{instance_ID}.eu-es.secrets-manager.appdomain.cloud`\n- Osaka: `https://{instance_ID}.jp-osa.secrets-manager.appdomain.cloud`\n- Sao Paulo: `https://{instance_ID}.br-sao.secrets-manager.appdomain.cloud`\n- Sydney: `https://{instance_ID}.au-syd.secrets-manager.appdomain.cloud`\n- Tokyo: `https://{instance_ID}.jp-tok.secrets-manager.appdomain.cloud`\n- Toronto: `https://{instance_ID}.ca-tor.secrets-manager.appdomain.cloud`\n- Montreal: `https://{instance_ID}.ca-mon.secrets-manager.appdomain.cloud`\n- Washington DC: `https://{instance_ID}.us-east.secrets-manager.appdomain.cloud`\n\nSecrets Manager supports instance-specific endpoint URLs that you can use to interact with the service over [public or private service endpoints](https://cloud.ibm.com/docs/secrets-manager?topic=secrets-manager-endpoints#service-endpoints). To target your Secrets Manager service instance by using the Python SDK, use the `set_service_url()` method. You can copy your endpoint URL from the **Endpoints** page in the Secrets Manager service dashboard.\n\n**Endpoint URLs by location**\n\n- Chennai - Airtel: `https://{instance_ID}.in-che.secrets-manager.appdomain.cloud` \n- Dallas: `https://{instance_ID}.us-south.secrets-manager.appdomain.cloud`\n- Frankfurt: `https://{instance_ID}.eu-de.secrets-manager.appdomain.cloud`\n- London: `https://{instance_ID}.eu-gb.secrets-manager.appdomain.cloud`\n- Madrid: `https://{instance_ID}.eu-es.secrets-manager.appdomain.cloud`\n- Osaka: `https://{instance_ID}.jp-osa.secrets-manager.appdomain.cloud`\n- Sao Paulo: `https://{instance_ID}.br-sao.secrets-manager.appdomain.cloud`\n- Sydney: `https://{instance_ID}.au-syd.secrets-manager.appdomain.cloud`\n- Tokyo: `https://{instance_ID}.jp-tok.secrets-manager.appdomain.cloud`\n- Toronto: `https://{instance_ID}.ca-tor.secrets-manager.appdomain.cloud`\n- Montreal: `https://{instance_ID}.ca-mon.secrets-manager.appdomain.cloud`\n- Washington DC: `https://{instance_ID}.us-east.secrets-manager.appdomain.cloud`\n\nSecrets Manager supports instance-specific endpoint URLs that you can use to interact with the service over [public or private service endpoints](https://cloud.ibm.com/docs/secrets-manager?topic=secrets-manager-endpoints#service-endpoints). To target your Secrets Manager service instance by using the Go SDK, use the `URL` parameter. You can copy your endpoint URL from the **Endpoints** page in the Secrets Manager service dashboard.\n\n**Endpoint URLs by location**\n\n- Chennai - Airtel: `https://{instance_ID}.in-che.secrets-manager.appdomain.cloud` \n- Dallas: `https://{instance_ID}.us-south.secrets-manager.appdomain.cloud`\n- Frankfurt: `https://{instance_ID}.eu-de.secrets-manager.appdomain.cloud`\n- London: `https://{instance_ID}.eu-gb.secrets-manager.appdomain.cloud`\n- Madrid: `https://{instance_ID}.eu-es.secrets-manager.appdomain.cloud`\n- Osaka: `https://{instance_ID}.jp-osa.secrets-manager.appdomain.cloud`\n- Sao Paulo: `https://{instance_ID}.br-sao.secrets-manager.appdomain.cloud`\n- Sydney: `https://{instance_ID}.au-syd.secrets-manager.appdomain.cloud`\n- Tokyo: `https://{instance_ID}.jp-tok.secrets-manager.appdomain.cloud`\n- Toronto: `https://{instance_ID}.ca-tor.secrets-manager.appdomain.cloud`\n- Montreal: `https://{instance_ID}.ca-mon.secrets-manager.appdomain.cloud`\n- Washington DC: `https://{instance_ID}.us-east.secrets-manager.appdomain.cloud`\n\nBase URL\n```\nhttps://{instance_ID}.{region}.secrets-manager.appdomain.cloud\n```\n\nExample for the Dallas location\n\n```java\nimport com.ibm.cloud.secrets_manager_sdk.secrets_manager.v2.SecretsManager;\nimport com.ibm.cloud.secrets_manager_sdk.secrets_manager.v2.model.*;\nimport com.ibm.cloud.sdk.core.http.Response;\nimport com.ibm.cloud.sdk.core.security.IamAuthenticator;\n\nimport java.util.Collections;\n...\n\n// Create an IAM authenticator\nIamAuthenticator iamAuthenticator = new IamAuthenticator.Builder()\n        .apikey(\"<API_KEY>\")\n        .build();\n\n// Construct the service client\nSecretsManager secretsManagerService = new SecretsManager(\"My Secrets-Manager service\", iamAuthenticator);\n\n// Set the service URL\nsecretsManagerService.setServiceUrl(\"https://{instance_ID}.us-south.secrets-manager.appdomain.cloud\");\n```\n\nExample for the Dallas location\n\n```javascript\nconst IbmCloudSecretsManagerApiV2 =  require('@ibm-cloud/secrets-manager/secrets-manager/v2');\nconst { IamAuthenticator } = require('@ibm-cloud/secrets-manager/auth');\n\nconst secretsManagerService = new SecretsManagerV2({\n  authenticator: new IamAuthenticator({\n    apikey: '<API_KEY>',\n  }),\n  serviceUrl: 'https://{instance_ID}.us-south.secrets-manager.appdomain.cloud',\n});\n```\n\nExample for the Dallas location\n\n```python\nfrom ibm_cloud_sdk_core.authenticators.iam_authenticator import IAMAuthenticator\nfrom ibm_secrets_manager_sdk.secrets_manager_v2 import *\n\nsecrets_manager_service = SecretsManagerV2(\n    authenticator=IAMAuthenticator(apikey='<API_KEY>')\n)\n\nsecrets_manager_service.set_service_url('https://{instance_ID}.us-south.secrets-manager.appdomain.cloud')\n```\n\nExample for the Dallas location\n\n```go\nimport (\n    \"encoding/json\"\n    \"fmt\"\n    \"github.com/IBM/go-sdk-core/v5/core\"\n    sm \"github.com/IBM/secrets-manager-go-sdk/secretsmanagerv2\"\n)\n\nfunc main() {\n\n    secretsManagerService, err := sm.NewSecretsManagerV2(&sm.SecretsManagerV2Options {\n        URL: \"https://{instance_ID}.us-south.secrets-manager.appdomain.cloud\",\n        Authenticator: & core.IamAuthenticator {\n            ApiKey: \"<API_KEY>\",\n        },\n    })\n\n    if err != nil {\n        panic(err)\n    }\n}\n```\n\n## Authentication\n\nAuthorization to the Secrets Manager API is enforced by using an IBM Cloud Identity and Access Management (IAM) access token. The token is used to determine the actions that a user or service ID has access to when they use the API.\n\nTo work with the API, include a valid IAM token in each outgoing request to the service. You can generate an access token by first [creating an API key](https://cloud.ibm.com/docs/account?topic=account-iamtoken_from_apikey) and then exchanging your API key for an IBM Cloud IAM token.\n\nDon't have an API key? Try running `ibmcloud iam oauth-tokens` in the [IBM Cloud Shell](https://cloud.ibm.com/shell) to quickly generate a personal access token.\n\nTo generate an access token from your API key, use the following cURL command.\n\n```bash\ncurl -X POST \\\n  \"https://iam.cloud.ibm.com/identity/token\" \\\n  --header 'Content-Type: application/x-www-form-urlencoded' \\\n  --header 'Accept: application/json' \\\n  --data-urlencode 'grant_type=urn:ibm:params:oauth:grant-type:apikey' \\\n  --data-urlencode 'apikey=<API_KEY>'\n```\n\nReplace `<API_KEY>` with your IBM Cloud API key.\n\nWhen you use the SDK, configure an IAM authenticator with an IBM Cloud IAM API key. The authenticator automatically obtains the IAM access token for the API key and includes it with each request. You can configure an authenticator in either of two ways:\n\n- Programmatically by constructing an IAM authenticator instance and supplying your IAM API key\n- By defining the API key in external configuration properties and then using the SDK authenticator factory to construct an IAM authenticator that uses the configured IAM API key\n\nFor more information, see the Authentication section of the [IBM Cloud SDK Common](https://github.com/IBM/ibm-cloud-sdk-common/blob/main/README.md#authentication) documentation.\n\nExample API request\n\n```bash\ncurl -X {request_method} \"{base_url}/api/v2/{method_endpoint}\" --header \"Authorization: Bearer {IAM_token}\"\n```\n\nReplace `{IAM_token}` with your access token.\n\nConstructing the service client\n\n```java\nimport com.ibm.cloud.secrets_manager_sdk.secrets_manager.v2.SecretsManager;\nimport com.ibm.cloud.secrets_manager_sdk.secrets_manager.v2.model.*;\nimport com.ibm.cloud.sdk.core.http.Response;\nimport com.ibm.cloud.sdk.core.security.IamAuthenticator;\n\nimport java.util.Collections;\n...\n\n// Create an IAM authenticator\nIamAuthenticator iamAuthenticator = new IamAuthenticator.Builder()\n        .apikey(\"<API_KEY>\")\n        .build();\n\n// Construct the service client\nSecretsManager secretsManagerService = new SecretsManager(\"My Secrets-Manager service\", iamAuthenticator);\n\n// Set the service URL\nsecretsManagerService.setServiceUrl(\"<URL>\");\n```\n\nReplace `<API_KEY>` with your IBM Cloud API key. Replace `<URL>` with the endpoint URL for your instance. Invoke service operations by using the `secretsManagerService` variable.\n\nConstructing the service client\n\n```python\nfrom ibm_cloud_sdk_core.authenticators.iam_authenticator import IAMAuthenticator\nfrom ibm_secrets_manager_sdk.secrets_manager_v2 import *\n\nsecrets_manager_service = SecretsManagerV2(\n    authenticator=IAMAuthenticator(apikey='<API_KEY>')\n)\n\nsecrets_manager_service.set_service_url('<URL>')\n```\n\nReplace `<API_KEY>` with your IBM Cloud API key. Replace `<URL>` with the endpoint URL for your instance.\n\nConstructing the service client\n\n```go\nimport (\n    \"encoding/json\"\n    \"fmt\"\n    \"github.com/IBM/go-sdk-core/v5/core\"\n    sm \"github.com/IBM/secrets-manager-go-sdk/secretsmanagerv2\"\n)\n\nfunc main() {\n\n    secretsManagerService, err := sm.NewSecretsManagerV2(&sm.SecretsManagerV2Options {\n        URL: \"<URL>\",\n        Authenticator: & core.IamAuthenticator {\n            ApiKey: \"<API_KEY>\",\n        },\n    })\n\n    if err != nil {\n        panic(err)\n    }\n}\n```\n\nReplace `<API_KEY>` with your IBM Cloud API key. Replace `<URL>` with the endpoint URL for your instance.\n\nConstructing the service client\n\n```javascript\nconst IbmCloudSecretsManagerApiV2 =  require('@ibm-cloud/secrets-manager/secrets-manager/v2');\nconst { IamAuthenticator } = require('@ibm-cloud/secrets-manager/auth');\n\nconst secretsManagerService = new IbmCloudSecretsManagerApiV2({\n  authenticator: new IamAuthenticator({\n    apikey: '<API_KEY>',\n  }),\n  serviceUrl: '<URL>',\n});\n```\n\nReplace `<API_KEY>` with your IBM Cloud API key. Replace `<URL>` with the endpoint URL for your instance.\n\n## Auditing\n\nYou can monitor API activity within your account by using the IBM Cloud Activity Tracker service. Whenever an API method is called, an event is generated that you can then track and audit from within Activity Tracker. The specific event type is listed for each individual method.\n\nFor more information about how to track Secrets Manager activity, see [Auditing events for Secrets Manager](https://cloud.ibm.com/docs/secrets-manager?topic=secrets-manager-at_events).\n\n## Error handling\n\nThe Secrets Manager APIs use standard [HTTP status codes](https://cloud.ibm.com/docs/api-handbook?topic=api-handbook-status-codes) to indicate whether a method completed successfully. HTTP response codes in the `2xx` range indicate success. A response in the `4xx` range is some sort of failure, and a response in the `5xx` range usually indicates an internal system error.\n\n<table>\n    <caption>Status code summary</caption>\n    <thead>\n        <tr>\n            <th>Status code</th>\n            <th>Description</th>\n        </tr>\n    </thead>\n    <tbody>\n        <tr>\n            <td>200\n            <span class=\"type\">OK</span></td>\n            <td>Everything worked as expected.</td>\n        </tr>\n        <tr>\n            <td>300\n            <span class=\"type\">Multiple Choices</span></td>\n            <td>The request has more than one possible responses.</td>\n        </tr>\n        <tr>\n            <td>400\n            <span class=\"type\">Bad Request</span></td>\n            <td>The request was unsuccessful, often due to a missing required parameter.</td>\n        </tr>\n        <tr>\n            <td>401\n            <span class=\"type\">Unauthorized</span></td>\n            <td>Access token is missing or invalid.</td>\n        </tr>\n        <tr>\n            <td>402\n            <span class=\"type\">Payment Required</span></td>\n            <td>Your Trial plan is now expired.</td>\n        </tr>\n        <tr>\n            <td>403\n            <span class=\"type\">Forbidden</span></td>\n            <td>You are not allowed to access this resource.</td>\n        </tr>\n        <tr>\n            <td>404\n            <span class=\"type\">Not Found</span></td>\n            <td>The requested resource doesn't exist.</td>\n        </tr>\n         <tr>\n            <td>409\n            <span class=\"type\">Conflict</span></td>\n            <td>The requested resource conflicts with an already existing resource.</td>\n        </tr>\n        <tr>\n            <td>410\n            <span class=\"type\">Gone</span></td>\n            <td>The requested resource was deleted and no longer exists.</td>\n        </tr>\n        <tr>\n            <td>429\n            <span class=\"type\">Too Many Requests</span></td>\n            <td>Too many requests hit the API too quickly.</td>\n        </tr>\n        <tr>\n            <td>500\n            <span class=\"type\">Internal Server Error</span></td>\n            <td>Something went wrong on Secrets Manager's end.</td>\n        </tr>\n    </tbody>\n</table>\n\nExample error handling\n\n```javascript\nsecretsManagerApi.method(params)\n  .catch(err => {\n    console.log('Error:', err);\n  });\n```\n\nExample error handling\n\n```go\nimport sm \"github.com/IBM/secrets-manager-go-sdk/v2/secretsmanagerv2\"\n\n// Instantiate a service\nsecretsManagerApi, err := sm.NewSecretsManagerV2(&sm.SecretsManagerV2Options)\n\n// Check for errors\nif err != nil {\n  panic(err)\n}\n\n// Call a method\nresult, response, err := secretsManagerApi.MethodName(&methodOptions)\n\n// Check for errors\nif err != nil {\n  panic(err)\n}\n```\n\n## Pagination\n\nSome API requests might return a large number of results. To avoid performance issues, the Secrets Manager API returns one page of results at a time, with a limited number of results on each page.\n\nThe default page size is defined differently for each operation. To use a different page size, use the `limit` query parameter.\n\n## Rate limiting\n\nSecrets Manager API does not enforce a hard rate-limit. However as requests rate increase, some performance degradation is expected. The impact depends on the requests patterns. As a rule of thumb it is recommended to keep the rate up to 20 requests per second.\n\n## Change log\n\nFor the latest changes, improvements, and updates for this API, see the [API change log](https://cloud.ibm.com/docs/secrets-manager?topic=secrets-manager-api-change-log).",
    "x-cli-description": "Use the IBM Cloud® Secrets Manager service to create and manage secrets that are used in other IBM Cloud services or your custom-built applications.",
    "x-codegen-config": {
      "go": {
        "apiPackage": "github.com/IBM/secrets-manager-go-sdk/v2"
      },
      "java": {
        "apiPackage": "com.ibm.cloud.secrets_manager_sdk"
      },
      "python": {
        "apiPackage": "ibm_secrets_manager_sdk"
      },
      "cli": {
        "apiPackage": "secrets-manager",
        "cliPluginName": "secrets-manager",
        "confirmDeleteOperations": true,
        "extendUtilities": true,
        "privateEndpointSupported": true,
        "serviceCommandAliases": [
          "sm"
        ],
        "singleServicePlugin": true,
        "createServiceUrlFlag": true
      },
      "terraform": null
    },
    "x-github": "https://github.ibm.com/cloud-api-docs/secrets-manager",
    "x-github-issues": "https://github.ibm.com/cloud-api-docs/secrets-manager/issues/new",
    "x-last-updated": "2022-12-09"
  },
  "security": [
    {
      "BearerAuth": []
    }
  ],
  "externalDocs": {
    "description": "For more information about this service, see the docs.",
    "url": "https://cloud.ibm.com/docs/secrets-manager",
    "x-cli-ref-url": "https://cloud.ibm.com/docs/secrets-manager?topic=secrets-manager-secrets-manager-cli"
  },
  "tags": [
    {
      "name": "Secret groups",
      "description": "Control who can access secrets by creating and managing groups."
    },
    {
      "name": "Secrets",
      "description": "Create, order, and manage different types of secrets for your apps and services."
    },
    {
      "name": "Secret versions",
      "description": "Create and manage the versions of your secrets."
    },
    {
      "name": "Secret tasks",
      "description": "Monitor and Update the tasks that belong to your secret."
    },
    {
      "name": "Secret locks",
      "description": "Secure your secret data by attaching a lock to a secret version and preventing any modification or deletion."
    },
    {
      "name": "Configurations",
      "description": "Create and manage configurations so that you can work with specific types of secrets."
    },
    {
      "name": "Notifications",
      "description": "Enable lifecycle notifications for your instance by connecting to Event Notifications."
    }
  ],
  "paths": {
    "/api/v2/secret_groups": {
      "post": {
        "summary": "Create a new secret group",
        "x-codegen-request-body-name": "SecretGroupPrototype",
        "x-activity-tracker": {
          "dataEvent": true,
          "targetTypeURI": "secrets-manager/secret-group",
          "description": "Create a secret group",
          "action": "secrets-manager.secret-group.create",
          "targetResourceType": "secret-group"
        },
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "secrets-manager.secret-group.create"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "secrets-manager.secret-group.create"
            }
          ]
        },
        "tags": [
          "Secret groups"
        ],
        "description": "Create a secret group that you can use to organize secrets and control who can access them.\n\nA successful request returns the ID value of the secret group, along with other properties. To learn more about\nsecret groups, check out the [docs](https://cloud.ibm.com/docs/secrets-manager?topic=secrets-manager-secret-groups).",
        "x-cli-description": "Create a secret group to organize secrets and control who can access them.",
        "operationId": "create_secret_group",
        "requestBody": {
          "description": "The request body to create a new secret group.\n",
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/SecretGroupPrototype"
              }
            }
          }
        },
        "responses": {
          "201": {
            "description": "The secret group was successfully created.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SecretGroup"
                },
                "examples": {
                  "SecretGroup": {
                    "$ref": "#/components/examples/SecretGroup"
                  }
                }
              }
            },
            "links": {
              "SecretGroupIdForGetSecretGroup": {
                "$ref": "#/components/links/SecretGroupIdForGetSecretGroup"
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "402": {
            "$ref": "#/components/responses/PaymentRequired"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/NotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          },
          "502": {
            "$ref": "#/components/responses/BadGatewayError"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X POST --location --header \"Authorization: Bearer ${iam_token}\" \\\n",
                      "  --header \"Accept: application/json\" \\\n",
                      "  --header \"Content-Type: application/json\" \\\n",
                      "  --data '{\"name\":\"my-secret-group\",\"description\":\"Extended description for this group.\"}' \\\n",
                      "  \"/api/v2/secret_groups\""
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "CreateSecretGroupOptions createSecretGroupOptions = new CreateSecretGroupOptions.Builder()\n",
                      "  .name(\"my-secret-group\")\n",
                      "  .build();\n",
                      "\n",
                      "Response<SecretGroup> response = secretsManagerService.createSecretGroup(createSecretGroupOptions).execute();\n",
                      "SecretGroup secretGroup = response.getResult();\n",
                      "\n",
                      "System.out.println(secretGroup);"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "const params = {\n",
                      "  name: 'my-secret-group',\n",
                      "};\n",
                      "\n",
                      "let res;\n",
                      "try {\n",
                      "  res = await secretsManagerService.createSecretGroup(params);\n",
                      "  console.log(JSON.stringify(res.result, null, 2));\n",
                      "} catch (err) {\n",
                      "  console.warn(err);\n",
                      "}"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "response = secrets_manager_service.create_secret_group(\n",
                      "  name='my-secret-group',\n",
                      ")\n",
                      "secret_group = response.get_result()\n",
                      "\n",
                      "print(json.dumps(secret_group, indent=2))"
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "createSecretGroupOptions := secretsManagerService.NewCreateSecretGroupOptions(\n",
                      "  \"my-secret-group\",\n",
                      ")\n",
                      "\n",
                      "secretGroup, response, err := secretsManagerService.CreateSecretGroup(createSecretGroupOptions)\n",
                      "if err != nil {\n",
                      "  panic(err)\n",
                      "}\n",
                      "b, _ := json.MarshalIndent(secretGroup, \"\", \"  \")\n",
                      "fmt.Println(string(b))"
                    ]
                  }
                ]
              }
            ]
          }
        }
      },
      "get": {
        "summary": "List secret groups",
        "x-activity-tracker": {
          "dataEvent": true,
          "targetTypeURI": "secrets-manager/secret-groups",
          "description": "List secret groups",
          "action": "secrets-manager.secret-groups.list"
        },
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "secrets-manager.secret-groups.list"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "secrets-manager.secret-groups.list"
            }
          ]
        },
        "tags": [
          "Secret groups"
        ],
        "description": "List the secret groups that are available in your Secrets Manager instance.",
        "x-cli-description": "List the secret groups that are available in your Secrets Manager instance.",
        "operationId": "list_secret_groups",
        "x-cli-table-filter-jmespath": "secret_groups[*]",
        "responses": {
          "200": {
            "description": "The list of secret groups was successfully retrieved.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SecretGroupCollection"
                },
                "examples": {
                  "SecretGroupCollection": {
                    "$ref": "#/components/examples/SecretGroupCollection"
                  }
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "402": {
            "$ref": "#/components/responses/PaymentRequired"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/NotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          },
          "502": {
            "$ref": "#/components/responses/BadGatewayError"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET --location --header \"Authorization: Bearer ${iam_token}\" \\\n",
                      "  --header \"Accept: application/json\" \\\n",
                      "  \"/api/v2/secret_groups\""
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "ListSecretGroupsOptions listSecretGroupsOptions = new ListSecretGroupsOptions();\n",
                      "\n",
                      "Response<SecretGroupCollection> response = secretsManagerService.listSecretGroups(listSecretGroupsOptions).execute();\n",
                      "SecretGroupCollection secretGroupCollection = response.getResult();\n",
                      "\n",
                      "System.out.println(secretGroupCollection);"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "let res;\n",
                      "try {\n",
                      "  res = await secretsManagerService.listSecretGroups({});\n",
                      "  console.log(JSON.stringify(res.result, null, 2));\n",
                      "} catch (err) {\n",
                      "  console.warn(err);\n",
                      "}"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "response = secrets_manager_service.list_secret_groups()\n",
                      "secret_group_collection = response.get_result()\n",
                      "\n",
                      "print(json.dumps(secret_group_collection, indent=2))"
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "listSecretGroupsOptions := secretsManagerService.NewListSecretGroupsOptions()\n",
                      "\n",
                      "secretGroupCollection, response, err := secretsManagerService.ListSecretGroups(listSecretGroupsOptions)\n",
                      "if err != nil {\n",
                      "  panic(err)\n",
                      "}\n",
                      "b, _ := json.MarshalIndent(secretGroupCollection, \"\", \"  \")\n",
                      "fmt.Println(string(b))"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/api/v2/secret_groups/{id}": {
      "get": {
        "summary": "Get a secret group",
        "x-activity-tracker": {
          "dataEvent": true,
          "targetTypeURI": "secrets-manager/secret-group",
          "description": "View the details of a secret group.",
          "targetResourceType": "secret-group",
          "action": "secrets-manager.secret-group.read"
        },
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "secrets-manager.secret-group.read"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "secrets-manager.secret-group.read"
            }
          ]
        },
        "tags": [
          "Secret groups"
        ],
        "description": "Get the properties of an existing secret group by specifying the ID of the group.",
        "x-cli-description": "Get the properties of a secret group.",
        "operationId": "get_secret_group",
        "parameters": [
          {
            "$ref": "#/components/parameters/SecretGroupId"
          }
        ],
        "responses": {
          "200": {
            "description": "The secret group was successfully retrieved.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SecretGroup"
                },
                "examples": {
                  "SecretGroup": {
                    "$ref": "#/components/examples/SecretGroup"
                  }
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "402": {
            "$ref": "#/components/responses/PaymentRequired"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/NotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          },
          "502": {
            "$ref": "#/components/responses/BadGatewayError"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET --location --header \"Authorization: Bearer ${iam_token}\" \\\n",
                      "  --header \"Accept: application/json\" \\\n",
                      "  \"/api/v2/secret_groups/secretGroupIdForGetSecretGroupLink\""
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "GetSecretGroupOptions getSecretGroupOptions = new GetSecretGroupOptions.Builder()\n",
                      "  .id(secretGroupIdForGetSecretGroupLink)\n",
                      "  .build();\n",
                      "\n",
                      "Response<SecretGroup> response = secretsManagerService.getSecretGroup(getSecretGroupOptions).execute();\n",
                      "SecretGroup secretGroup = response.getResult();\n",
                      "\n",
                      "System.out.println(secretGroup);"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "const params = {\n",
                      "  id: secretGroupIdForGetSecretGroupLink,\n",
                      "};\n",
                      "\n",
                      "let res;\n",
                      "try {\n",
                      "  res = await secretsManagerService.getSecretGroup(params);\n",
                      "  console.log(JSON.stringify(res.result, null, 2));\n",
                      "} catch (err) {\n",
                      "  console.warn(err);\n",
                      "}"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "response = secrets_manager_service.get_secret_group(\n",
                      "  id=secret_group_id_for_get_secret_group_link,\n",
                      ")\n",
                      "secret_group = response.get_result()\n",
                      "\n",
                      "print(json.dumps(secret_group, indent=2))"
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "getSecretGroupOptions := secretsManagerService.NewGetSecretGroupOptions(\n",
                      "  secretGroupIdForGetSecretGroupLink,\n",
                      ")\n",
                      "\n",
                      "secretGroup, response, err := secretsManagerService.GetSecretGroup(getSecretGroupOptions)\n",
                      "if err != nil {\n",
                      "  panic(err)\n",
                      "}\n",
                      "b, _ := json.MarshalIndent(secretGroup, \"\", \"  \")\n",
                      "fmt.Println(string(b))"
                    ]
                  }
                ]
              }
            ]
          }
        }
      },
      "patch": {
        "summary": "Update a secret group",
        "x-activity-tracker": {
          "dataEvent": true,
          "targetTypeURI": "secrets-manager/secret-group",
          "description": "Update a secret group",
          "targetResourceType": "secret-group",
          "action": "secrets-manager.secret-group.update"
        },
        "x-codegen-request-body-name": "SecretGroupPatch",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "secrets-manager.secret-group.update"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "secrets-manager.secret-group.update"
            }
          ]
        },
        "tags": [
          "Secret groups"
        ],
        "description": "Update the properties of an existing secret group, such as its name or description.",
        "x-cli-description": "Update the properties of a secret group, such as its name or description.",
        "operationId": "update_secret_group",
        "parameters": [
          {
            "$ref": "#/components/parameters/SecretGroupIdNoDefault"
          }
        ],
        "requestBody": {
          "description": "The request body to update a secret group.\n",
          "required": true,
          "content": {
            "application/merge-patch+json": {
              "schema": {
                "$ref": "#/components/schemas/SecretGroupPatch"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "The secret group was successfully updated.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SecretGroup"
                },
                "examples": {
                  "SecretGroup": {
                    "$ref": "#/components/examples/SecretGroup"
                  }
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "402": {
            "$ref": "#/components/responses/PaymentRequired"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/NotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          },
          "502": {
            "$ref": "#/components/responses/BadGatewayError"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X PATCH --location --header \"Authorization: Bearer ${iam_token}\" \\\n",
                      "  --header \"Accept: application/json\" \\\n",
                      "  --header \"Content-Type: application/merge-patch+json\" \\\n",
                      "  --data '' \\\n",
                      "  \"/api/v2/secret_groups/secretGroupIdForGetSecretGroupLink\""
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "SecretGroupPatch secretGroupPatchModel = new SecretGroupPatch.Builder()\n",
                      "  .build();\n",
                      "Map<String, Object> secretGroupPatchModelAsPatch = secretGroupPatchModel.asPatch();\n",
                      "UpdateSecretGroupOptions updateSecretGroupOptions = new UpdateSecretGroupOptions.Builder()\n",
                      "  .id(secretGroupIdForGetSecretGroupLink)\n",
                      "  .secretGroupPatch(secretGroupPatchModelAsPatch)\n",
                      "  .build();\n",
                      "\n",
                      "Response<SecretGroup> response = secretsManagerService.updateSecretGroup(updateSecretGroupOptions).execute();\n",
                      "SecretGroup secretGroup = response.getResult();\n",
                      "\n",
                      "System.out.println(secretGroup);"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "const params = {\n",
                      "  id: secretGroupIdForGetSecretGroupLink,\n",
                      "};\n",
                      "\n",
                      "let res;\n",
                      "try {\n",
                      "  res = await secretsManagerService.updateSecretGroup(params);\n",
                      "  console.log(JSON.stringify(res.result, null, 2));\n",
                      "} catch (err) {\n",
                      "  console.warn(err);\n",
                      "}"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "secret_group_patch_model = {\n",
                      "}\n",
                      "\n",
                      "response = secrets_manager_service.update_secret_group(\n",
                      "  id=secret_group_id_for_get_secret_group_link,\n",
                      "  secret_group_patch=secret_group_patch_model,\n",
                      ")\n",
                      "secret_group = response.get_result()\n",
                      "\n",
                      "print(json.dumps(secret_group, indent=2))"
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "secretGroupPatchModel := &secretsmanagerv2.SecretGroupPatch{\n",
                      "}\n",
                      "secretGroupPatchModelAsPatch, asPatchErr := secretGroupPatchModel.AsPatch()\n",
                      "Expect(asPatchErr).To(BeNil())\n",
                      "\n",
                      "updateSecretGroupOptions := secretsManagerService.NewUpdateSecretGroupOptions(\n",
                      "  secretGroupIdForGetSecretGroupLink,\n",
                      "  secretGroupPatchModelAsPatch,\n",
                      ")\n",
                      "\n",
                      "secretGroup, response, err := secretsManagerService.UpdateSecretGroup(updateSecretGroupOptions)\n",
                      "if err != nil {\n",
                      "  panic(err)\n",
                      "}\n",
                      "b, _ := json.MarshalIndent(secretGroup, \"\", \"  \")\n",
                      "fmt.Println(string(b))"
                    ]
                  }
                ]
              }
            ]
          }
        }
      },
      "delete": {
        "summary": "Delete a secret group",
        "x-activity-tracker": {
          "dataEvent": true,
          "targetTypeURI": "secrets-manager/secret-group",
          "description": "Delete a secret group.",
          "targetResourceType": "secret-group",
          "action": "secrets-manager.secret-group.delete"
        },
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "secrets-manager.secret-group.delete"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "secrets-manager.secret-group.delete"
            }
          ]
        },
        "tags": [
          "Secret groups"
        ],
        "description": "Delete a secret group by specifying the ID of the secret group.\n\n**Note:** To delete a secret group, it must be empty. If you need to remove a secret group that contains secrets,\nyou must first delete the secrets that are associated with the group.",
        "x-cli-description": "Delete a secret group. To delete a group that contains secrets, be sure to first delete the secrets that are associated with the group.",
        "operationId": "delete_secret_group",
        "parameters": [
          {
            "$ref": "#/components/parameters/SecretGroupIdNoDefault"
          }
        ],
        "responses": {
          "204": {
            "description": "The secret group was successfully deleted."
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "402": {
            "$ref": "#/components/responses/PaymentRequired"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/NotFound"
          },
          "409": {
            "$ref": "#/components/responses/Conflict"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          },
          "502": {
            "$ref": "#/components/responses/BadGatewayError"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X DELETE --location --header \"Authorization: Bearer ${iam_token}\" \\\n",
                      "  \"/api/v2/secret_groups/secretGroupIdForGetSecretGroupLink\""
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "DeleteSecretGroupOptions deleteSecretGroupOptions = new DeleteSecretGroupOptions.Builder()\n",
                      "  .id(secretGroupIdForGetSecretGroupLink)\n",
                      "  .build();\n",
                      "\n",
                      "Response<Void> response = secretsManagerService.deleteSecretGroup(deleteSecretGroupOptions).execute();"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "const params = {\n",
                      "  id: secretGroupIdForGetSecretGroupLink,\n",
                      "};\n",
                      "\n",
                      "try {\n",
                      "  await secretsManagerService.deleteSecretGroup(params);\n",
                      "} catch (err) {\n",
                      "  console.warn(err);\n",
                      "}"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "response = secrets_manager_service.delete_secret_group(\n",
                      "  id=secret_group_id_for_get_secret_group_link,\n",
                      ")"
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "deleteSecretGroupOptions := secretsManagerService.NewDeleteSecretGroupOptions(\n",
                      "  secretGroupIdForGetSecretGroupLink,\n",
                      ")\n",
                      "\n",
                      "response, err := secretsManagerService.DeleteSecretGroup(deleteSecretGroupOptions)\n",
                      "if err != nil {\n",
                      "  panic(err)\n",
                      "}\n",
                      "if response.StatusCode != 204 {\n",
                      "  fmt.Printf(\"\\nUnexpected response status code received from DeleteSecretGroup(): %d\\n\", response.StatusCode)\n",
                      "}"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/api/v2/secrets": {
      "post": {
        "summary": "Create a new secret",
        "x-codegen-request-body-name": "SecretPrototype",
        "x-activity-tracker": {
          "dataEvent": true,
          "targetTypeURI": "secrets-manager/secret",
          "description": "Create a new secret",
          "action": "secrets-manager.secret.create",
          "targetResourceType": "secret"
        },
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "secrets-manager.secret.create"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "secrets-manager.secret.create"
            }
          ]
        },
        "tags": [
          "Secrets"
        ],
        "description": "Create a secret or import an existing value that you can use to access or authenticate to a protected resource.\n\nUse this operation to either generate or import an existing secret, such as a TLS certificate,\nthat you can manage in your Secrets Manager service instance. A successful request stores the secret in your\ndedicated instance, based on the secret type and data that you specify. The response returns the ID value of the\nsecret, along with other metadata.\n\nTo learn more about the types of secrets that you can create with Secrets Manager, check out the [docs](https://cloud.ibm.com/docs/secrets-manager?topic=secrets-manager-what-is-secret).",
        "x-cli-description": "Create a secret and store it in your instance.",
        "operationId": "create_secret",
        "x-terraform-polling-operation": "get_secret",
        "x-terraform-polling-property": "state_description",
        "x-terraform-polling-success": "active",
        "x-terraform-polling-pending": "pre_activation",
        "x-terraform-polling-failure": "destroyed",
        "x-sdk-operations": {
          "request-examples": {
            "cli": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "ibmcloud secrets-manager secret-create --secret-name=example-arbitrary-secret --secret-type=arbitrary --arbitrary-payload=example-secret-data",
                      "\n\n",
                      "ibmcloud secrets-manager secret-create \\\n",
                      "  --secret-prototype='{\"name\": \"example-arbitrary-secret\", \"secret_type\": \"arbitrary\", \"payload\":\"example-secret-data\"}'\n"
                    ]
                  }
                ]
              }
            ],
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X POST --location --header \"Authorization: Bearer ${iam_token}\" \\\n",
                      "  --header \"Accept: application/json\" \\\n",
                      "  --header \"Content-Type: application/json\" \\\n",
                      "  --data '{ \"custom_metadata\": { \"metadata_custom_key\": \"metadata_custom_value\" }, \"description\": \"Description of my arbitrary secret.\", \"expiration_date\": \"2030-10-05T11:49:42Z\", \"labels\": [ \"dev\", \"us-south\" ], \"name\": \"example-arbitrary-secret\", \"payload\": \"secret-data\", \"secret_group_id\": \"default\", \"secret_type\": \"arbitrary\", \"version_custom_metadata\": { \"custom_version_key\": \"custom_version_value\" } }' \\\n",
                      "  \"/api/v2/secrets\""
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "ArbitrarySecretPrototype secretPrototypeModel = new ArbitrarySecretPrototype.Builder()\n",
                      "  .description(\"Description of my arbitrary secret.\")\n",
                      "  .expirationDate(DateUtils.parseAsDateTime(\"2030-10-05T11:49:42Z\"))\n",
                      "  .labels(java.util.Arrays.asList(\"dev\", \"us-south\"))\n",
                      "  .name(\"example-arbitrary-secret\")\n",
                      "  .secretGroupId(\"default\")\n",
                      "  .secretType(\"arbitrary\")\n",
                      "  .payload(\"secret-data\")\n",
                      "  .build();\n",
                      "CreateSecretOptions createSecretOptions = new CreateSecretOptions.Builder()\n",
                      "  .secretPrototype(secretPrototypeModel)\n",
                      "  .build();\n",
                      "\n",
                      "Response<Secret> response = secretsManagerService.createSecret(createSecretOptions).execute();\n",
                      "Secret secret = response.getResult();\n",
                      "\n",
                      "System.out.println(secret);"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "// Request models needed by this operation.\n",
                      "\n",
                      "// ArbitrarySecretPrototype\n",
                      "const secretPrototypeModel = {\n",
                      "  custom_metadata: { metadata_custom_key: 'metadata_custom_value' },\n",
                      "  description: 'Description of my arbitrary secret.',\n",
                      "  expiration_date: '2030-10-05T11:49:42Z',\n",
                      "  labels: ['dev', 'us-south'],\n",
                      "  name: 'example-arbitrary-secret',\n",
                      "  secret_group_id: 'default',\n",
                      "  secret_type: 'arbitrary',\n",
                      "  payload: 'secret-data',\n",
                      "  version_custom_metadata: { custom_version_key: 'custom_version_value' },\n",
                      "};\n",
                      "\n",
                      "const params = {\n",
                      "  secretPrototype: secretPrototypeModel,\n",
                      "};\n",
                      "\n",
                      "let res;\n",
                      "try {\n",
                      "  res = await secretsManagerService.createSecret(params);\n",
                      "  console.log(JSON.stringify(res.result, null, 2));\n",
                      "} catch (err) {\n",
                      "  console.warn(err);\n",
                      "}"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "secret_prototype_model = {\n",
                      "  'custom_metadata': {'metadata_custom_key': 'metadata_custom_value'},\n",
                      "  'description': 'Description of my arbitrary secret.',\n",
                      "  'expiration_date': '2030-10-05T11:49:42Z',\n",
                      "  'labels': ['dev', 'us-south'],\n",
                      "  'name': 'example-arbitrary-secret',\n",
                      "  'secret_group_id': 'default',\n",
                      "  'secret_type': 'arbitrary',\n",
                      "  'payload': 'secret-data',\n",
                      "  'version_custom_metadata': {'custom_version_key': 'custom_version_value'},\n",
                      "}\n",
                      "\n",
                      "response = secrets_manager_service.create_secret(\n",
                      "  secret_prototype=secret_prototype_model,\n",
                      ")\n",
                      "secret = response.get_result()\n",
                      "\n",
                      "print(json.dumps(secret, indent=2))"
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "secretPrototypeModel := &secretsmanagerv2.ArbitrarySecretPrototype{\n",
                      "  Description: core.StringPtr(\"Description of my arbitrary secret.\"),\n",
                      "  Labels: []string{\"dev\", \"us-south\"},\n",
                      "  Name: core.StringPtr(\"example-arbitrary-secret\"),\n",
                      "  SecretGroupID: core.StringPtr(\"default\"),\n",
                      "  SecretType: core.StringPtr(\"arbitrary\"),\n",
                      "  Payload: core.StringPtr(\"secret-data\"),\n",
                      "}\n",
                      "\n",
                      "createSecretOptions := secretsManagerService.NewCreateSecretOptions(\n",
                      "  secretPrototypeModel,\n",
                      ")\n",
                      "\n",
                      "secret, response, err := secretsManagerService.CreateSecret(createSecretOptions)\n",
                      "if err != nil {\n",
                      "  panic(err)\n",
                      "}\n",
                      "b, _ := json.MarshalIndent(secret, \"\", \"  \")\n",
                      "fmt.Println(string(b))"
                    ]
                  }
                ]
              }
            ]
          }
        },
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/SecretPrototype"
              },
              "examples": {
                "ArbitrarySecretPrototype": {
                  "$ref": "#/components/examples/ArbitrarySecretPrototype"
                },
                "IAMCredentialsSecretServiceIDPrototype": {
                  "$ref": "#/components/examples/IAMCredentialsSecretServiceIDPrototype"
                },
                "ImportedCertificatePrototype": {
                  "$ref": "#/components/examples/ImportedCertificatePrototype"
                },
                "ImportedCertificateManagedCsrPrototype": {
                  "$ref": "#/components/examples/ImportedCertificateManagedCsrCreatePrototype"
                },
                "KVSecretPrototype": {
                  "$ref": "#/components/examples/KVSecretPrototype"
                },
                "PrivateCertificatePrototype": {
                  "$ref": "#/components/examples/PrivateCertificatePrototype"
                },
                "PublicCertificatePrototype": {
                  "$ref": "#/components/examples/PublicCertificatePrototype"
                },
                "ServiceCredentialsSecretPrototype": {
                  "$ref": "#/components/examples/ServiceCredentialsSecretPrototype"
                },
                "UsernamePasswordSecretPrototype": {
                  "$ref": "#/components/examples/UsernamePasswordSecretPrototype"
                },
                "IAMCredentialsSecretAccessGroupPrototype": {
                  "$ref": "#/components/examples/IAMCredentialsSecretAccessGroupPrototype"
                },
                "CustomCredentialsSecretPrototype": {
                  "$ref": "#/components/examples/CustomCredentialsSecretPrototype"
                }
              }
            }
          }
        },
        "responses": {
          "201": {
            "description": "The secret was successfully created.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Secret"
                },
                "examples": {
                  "ArbitrarySecret": {
                    "$ref": "#/components/examples/ArbitrarySecret"
                  },
                  "IAMCredentialsSecret": {
                    "$ref": "#/components/examples/IAMCredentialsSecretPrototypeResponse"
                  },
                  "ImportedCertificate": {
                    "$ref": "#/components/examples/ImportedCertificate"
                  },
                  "ImportedCertificateManagedCsr": {
                    "$ref": "#/components/examples/ImportedCertificateManagedCsrCreate"
                  },
                  "KVSecret": {
                    "$ref": "#/components/examples/KVSecret"
                  },
                  "PrivateCertificate": {
                    "$ref": "#/components/examples/PrivateCertificate"
                  },
                  "PublicCertificate": {
                    "$ref": "#/components/examples/PublicCertificateCreated"
                  },
                  "ServiceCredentialsSecret": {
                    "$ref": "#/components/examples/ServiceCredentialsSecret"
                  },
                  "UsernamePasswordSecret": {
                    "$ref": "#/components/examples/UsernamePasswordSecret"
                  },
                  "CustomCredentialsSecret": {
                    "$ref": "#/components/examples/CustomCredentialsSecretCreated"
                  }
                }
              }
            },
            "links": {
              "SecretIdForGetSecret": {
                "$ref": "#/components/links/SecretIdForGetSecret"
              },
              "SecretIdForGetSecretVersion": {
                "$ref": "#/components/links/SecretIdForGetSecretVersion"
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "402": {
            "$ref": "#/components/responses/PaymentRequired"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/NotFound"
          },
          "409": {
            "$ref": "#/components/responses/Conflict"
          },
          "422": {
            "$ref": "#/components/responses/UnprocessableEntity"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          },
          "502": {
            "$ref": "#/components/responses/BadGatewayError"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError"
          }
        }
      },
      "get": {
        "summary": "List secrets",
        "x-activity-tracker": {
          "dataEvent": true,
          "targetTypeURI": "secrets-manager/secrets",
          "description": "List secrets",
          "action": "secrets-manager.secrets.list"
        },
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "secrets-manager.secrets.list"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "secrets-manager.secrets.list"
            }
          ]
        },
        "tags": [
          "Secrets"
        ],
        "description": "List the secrets that are available in your Secrets Manager instance.",
        "x-cli-description": "List the secrets that are available in your Secrets Manager instance.",
        "x-cli-table-filter-jmespath": "secrets[*].{Name:name,ID:id,Secret_Type:secret_type,secret_group_id:secret_group_id,State:state_description,Locks:locks_total,Expiration:expiration_date}",
        "operationId": "list_secrets",
        "parameters": [
          {
            "$ref": "#/components/parameters/SecretCollectionOffsetParam"
          },
          {
            "$ref": "#/components/parameters/SecretCollectionLimitParam"
          },
          {
            "$ref": "#/components/parameters/SecretCollectionSortParam"
          },
          {
            "$ref": "#/components/parameters/SecretCollectionSearchParam"
          },
          {
            "$ref": "#/components/parameters/SecretCollectionGroupsParam"
          },
          {
            "$ref": "#/components/parameters/SecretCollectionTypesParam"
          },
          {
            "$ref": "#/components/parameters/SecretCollectionLabelsParam"
          }
        ],
        "responses": {
          "200": {
            "description": "The list of secrets was successfully retrieved.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SecretMetadataPaginatedCollection"
                },
                "examples": {
                  "SecretMetadataPaginatedCollection": {
                    "$ref": "#/components/examples/SecretMetadataPaginatedCollection"
                  }
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "402": {
            "$ref": "#/components/responses/PaymentRequired"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/NotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          },
          "502": {
            "$ref": "#/components/responses/BadGatewayError"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET --location --header \"Authorization: Bearer ${iam_token}\" \\\n",
                      "  --header \"Accept: application/json\" \\\n",
                      "  \"/api/v2/secrets?sort=created_at&search=example&groups=[ \\\"default\\\", \\\"cac40995-c37a-4dcb-9506-472869077634\\\" ]&secret_types=[ \\\"arbitrary\\\", \\\"kv\\\" ]&match_all_labels=[ \\\"dev\\\", \\\"us-south\\\" ]\""
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "ListSecretsOptions listSecretsOptions = new ListSecretsOptions.Builder()\n",
                      "  .limit(Long.valueOf(\"10\"))\n",
                      "  .sort(\"created_at\")\n",
                      "  .search(\"example\")\n",
                      "  .groups(java.util.Arrays.asList(\"default\", \"cac40995-c37a-4dcb-9506-472869077634\"))\n",
                      "  .secretTypes(java.util.Arrays.asList(\"arbitrary\", \"kv\"))\n",
                      "  .matchAllLabels(java.util.Arrays.asList(\"dev\", \"us-south\"))\n",
                      "  .build();\n",
                      "\n",
                      "SecretsPager pager = new SecretsPager(secretsManagerService, listSecretsOptions);\n",
                      "List<SecretMetadata> allResults = new ArrayList<>();\n",
                      "while (pager.hasNext()) {\n",
                      "  List<SecretMetadata> nextPage = pager.getNext();\n",
                      "  allResults.addAll(nextPage);\n",
                      "}\n",
                      "\n",
                      "System.out.println(GsonSingleton.getGson().toJson(allResults));"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "const params = {\n",
                      "  limit: 10,\n",
                      "  sort: 'created_at',\n",
                      "  search: 'example',\n",
                      "  groups: ['default', 'cac40995-c37a-4dcb-9506-472869077634'],\n",
                      "  secretTypes: ['arbitrary', 'kv'],\n",
                      "  matchAllLabels: ['dev', 'us-south'],\n",
                      "};\n",
                      "\n",
                      "const allResults = [];\n",
                      "try {\n",
                      "  const pager = new SecretsManagerV2.SecretsPager(secretsManagerService, params);\n",
                      "  while (pager.hasNext()) {\n",
                      "    const nextPage = await pager.getNext();\n",
                      "    expect(nextPage).not.toBeNull();\n",
                      "    allResults.push(...nextPage);\n",
                      "  }\n",
                      "  console.log(JSON.stringify(allResults, null, 2));\n",
                      "} catch (err) {\n",
                      "  console.warn(err);\n",
                      "}"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "all_results = []\n",
                      "pager = SecretsPager(\n",
                      "  client=secrets_manager_service,\n",
                      "  limit=10,\n",
                      "  sort='created_at',\n",
                      "  search='example',\n",
                      "  groups=['default', 'cac40995-c37a-4dcb-9506-472869077634'],\n",
                      "  secret_types=['arbitrary', 'kv'],\n",
                      "  match_all_labels=['dev', 'us-south'],\n",
                      ")\n",
                      "while pager.has_next():\n",
                      "  next_page = pager.get_next()\n",
                      "  assert next_page is not None\n",
                      "  all_results.extend(next_page)\n",
                      "\n",
                      "print(json.dumps(all_results, indent=2))"
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "listSecretsOptions := &secretsmanagerv2.ListSecretsOptions{\n",
                      "  Limit: core.Int64Ptr(int64(10)),\n",
                      "  Sort: core.StringPtr(\"created_at\"),\n",
                      "  Search: core.StringPtr(\"example\"),\n",
                      "  Groups: []string{\"default\", \"cac40995-c37a-4dcb-9506-472869077634\"},\n",
                      "  SecretTypes: []string{\"arbitrary\", \"kv\"},\n",
                      "  MatchAllLabels: []string{\"dev\", \"us-south\"},\n",
                      "}\n",
                      "\n",
                      "pager, err := secretsManagerService.NewSecretsPager(listSecretsOptions)\n",
                      "if err != nil {\n",
                      "  panic(err)\n",
                      "}\n",
                      "\n",
                      "var allResults []secretsmanagerv2.SecretMetadataIntf\n",
                      "for pager.HasNext() {\n",
                      "  nextPage, err := pager.GetNext()\n",
                      "  if err != nil {\n",
                      "    panic(err)\n",
                      "  }\n",
                      "  allResults = append(allResults, nextPage...)\n",
                      "}\n",
                      "b, _ := json.MarshalIndent(allResults, \"\", \"  \")\n",
                      "fmt.Println(string(b))"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/api/v2/secrets/{id}": {
      "parameters": [
        {
          "$ref": "#/components/parameters/SecretId"
        }
      ],
      "get": {
        "summary": "Get a secret",
        "x-activity-tracker": {
          "dataEvent": true,
          "targetTypeURI": "secrets-manager/secret",
          "description": "View the details of a secret",
          "targetResourceType": "secret",
          "action": "secrets-manager.secret.read"
        },
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "secrets-manager.secret.read"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "secrets-manager.secret.read"
            }
          ]
        },
        "tags": [
          "Secrets"
        ],
        "description": "Get a secret and its details by specifying the ID of the secret.\n\nA successful request returns the secret data that is associated with your secret, along with other metadata. To\nview only the details of a specified secret without retrieving its value, use the Get secret metadata operation.",
        "x-cli-description": "Get a secret and its details. This command returns the secret data that is associated with your secret.",
        "operationId": "get_secret",
        "responses": {
          "200": {
            "description": "The secret was successfully retrieved.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Secret"
                },
                "examples": {
                  "ArbitrarySecret": {
                    "$ref": "#/components/examples/ArbitrarySecret"
                  },
                  "IAMCredentialsSecret": {
                    "$ref": "#/components/examples/IAMCredentialsSecret"
                  },
                  "ImportedCertificate": {
                    "$ref": "#/components/examples/ImportedCertificate"
                  },
                  "KVSecret": {
                    "$ref": "#/components/examples/KVSecret"
                  },
                  "PrivateCertificate": {
                    "$ref": "#/components/examples/PrivateCertificate"
                  },
                  "PublicCertificate": {
                    "$ref": "#/components/examples/PublicCertificate"
                  },
                  "ServiceCredentialsSecret": {
                    "$ref": "#/components/examples/ServiceCredentialsSecret"
                  },
                  "UsernamePasswordSecret": {
                    "$ref": "#/components/examples/UsernamePasswordSecret"
                  },
                  "CustomCredentialsSecret": {
                    "$ref": "#/components/examples/CustomCredentialsSecret"
                  }
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "402": {
            "$ref": "#/components/responses/PaymentRequired"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/NotFound"
          },
          "409": {
            "$ref": "#/components/responses/Conflict"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          },
          "502": {
            "$ref": "#/components/responses/BadGatewayError"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET --location --header \"Authorization: Bearer ${iam_token}\" \\\n",
                      "  --header \"Accept: application/json\" \\\n",
                      "  \"/api/v2/secrets/secretIdForGetSecretLink\""
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "GetSecretOptions getSecretOptions = new GetSecretOptions.Builder()\n",
                      "  .id(secretIdForGetSecretLink)\n",
                      "  .build();\n",
                      "\n",
                      "Response<Secret> response = secretsManagerService.getSecret(getSecretOptions).execute();\n",
                      "Secret secret = response.getResult();\n",
                      "\n",
                      "System.out.println(secret);"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "const params = {\n",
                      "  id: secretIdForGetSecretLink,\n",
                      "};\n",
                      "\n",
                      "let res;\n",
                      "try {\n",
                      "  res = await secretsManagerService.getSecret(params);\n",
                      "  console.log(JSON.stringify(res.result, null, 2));\n",
                      "} catch (err) {\n",
                      "  console.warn(err);\n",
                      "}"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "response = secrets_manager_service.get_secret(\n",
                      "  id=secret_id_for_get_secret_link,\n",
                      ")\n",
                      "secret = response.get_result()\n",
                      "\n",
                      "print(json.dumps(secret, indent=2))"
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "getSecretOptions := secretsManagerService.NewGetSecretOptions(\n",
                      "  secretIdForGetSecretLink,\n",
                      ")\n",
                      "\n",
                      "secret, response, err := secretsManagerService.GetSecret(getSecretOptions)\n",
                      "if err != nil {\n",
                      "  panic(err)\n",
                      "}\n",
                      "b, _ := json.MarshalIndent(secret, \"\", \"  \")\n",
                      "fmt.Println(string(b))"
                    ]
                  }
                ]
              }
            ]
          }
        }
      },
      "delete": {
        "summary": "Delete a secret",
        "x-activity-tracker": {
          "dataEvent": true,
          "targetTypeURI": "secrets-manager/secret",
          "description": "Delete a secret",
          "targetResourceType": "secret",
          "action": "secrets-manager.secret.delete"
        },
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "secrets-manager.secret.delete"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "secrets-manager.secret.delete"
            }
          ]
        },
        "tags": [
          "Secrets"
        ],
        "description": "Delete a secret by specifying the ID of the secret.",
        "x-cli-description": "Delete a secret.",
        "operationId": "delete_secret",
        "parameters": [
          {
            "name": "force_delete",
            "in": "query",
            "description": "Set to `true` to force delete the secret. Available only for custom credentials secret type.",
            "required": false,
            "schema": {
              "type": "boolean",
              "default": false
            }
          }
        ],
        "responses": {
          "204": {
            "description": "The secret was successfully deleted."
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "402": {
            "$ref": "#/components/responses/PaymentRequired"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/NotFound"
          },
          "409": {
            "$ref": "#/components/responses/Conflict"
          },
          "422": {
            "$ref": "#/components/responses/UnprocessableEntity"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          },
          "502": {
            "$ref": "#/components/responses/BadGatewayError"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X DELETE --location --header \"Authorization: Bearer ${iam_token}\" \\\n",
                      "  \"/api/v2/secrets/secretIdForGetSecretLink\""
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "DeleteSecretOptions deleteSecretOptions = new DeleteSecretOptions.Builder()\n",
                      "  .id(secretIdForGetSecretLink)\n",
                      "  .build();\n",
                      "\n",
                      "Response<Void> response = secretsManagerService.deleteSecret(deleteSecretOptions).execute();"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "const params = {\n",
                      "  id: secretIdForGetSecretLink,\n",
                      "};\n",
                      "\n",
                      "try {\n",
                      "  await secretsManagerService.deleteSecret(params);\n",
                      "} catch (err) {\n",
                      "  console.warn(err);\n",
                      "}"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "response = secrets_manager_service.delete_secret(\n",
                      "  id=secret_id_for_get_secret_link,\n",
                      ")"
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "deleteSecretOptions := secretsManagerService.NewDeleteSecretOptions(\n",
                      "  secretIdForGetSecretLink,\n",
                      ")\n",
                      "\n",
                      "response, err := secretsManagerService.DeleteSecret(deleteSecretOptions)\n",
                      "if err != nil {\n",
                      "  panic(err)\n",
                      "}\n",
                      "if response.StatusCode != 204 {\n",
                      "  fmt.Printf(\"\\nUnexpected response status code received from DeleteSecret(): %d\\n\", response.StatusCode)\n",
                      "}"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/api/v2/secrets/{id}/metadata": {
      "parameters": [
        {
          "$ref": "#/components/parameters/SecretId"
        }
      ],
      "get": {
        "summary": "Get the metadata of a secret",
        "x-activity-tracker": {
          "dataEvent": true,
          "targetTypeURI": "secrets-manager/secret-metadata",
          "description": "View the details of a secret metadata",
          "targetResourceType": "secret",
          "action": "secrets-manager.secret-metadata.read"
        },
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "secrets-manager.secret-metadata.read"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "secrets-manager.secret-metadata.read"
            }
          ]
        },
        "tags": [
          "Secrets"
        ],
        "description": "Get the metadata of a secret by specifying the ID of the secret.",
        "x-cli-description": "Get the metadata of a secret.",
        "operationId": "get_secret_metadata",
        "responses": {
          "200": {
            "description": "The secret metadata was successfully retrieved.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SecretMetadata"
                },
                "examples": {
                  "ArbitrarySecretMetadata": {
                    "$ref": "#/components/examples/ArbitrarySecretMetadata"
                  },
                  "IAMCredentialsSecretMetadata": {
                    "$ref": "#/components/examples/IAMCredentialsSecretMetadata"
                  },
                  "ImportedCertificateMetadata": {
                    "$ref": "#/components/examples/ImportedCertificateMetadata"
                  },
                  "KVSecretMetadata": {
                    "$ref": "#/components/examples/KVSecretMetadata"
                  },
                  "PrivateCertificateMetadata": {
                    "$ref": "#/components/examples/PrivateCertificateMetadata"
                  },
                  "PublicCertificateMetadata": {
                    "$ref": "#/components/examples/PublicCertificateMetadata"
                  },
                  "ServiceCredentialsSecretMetadata": {
                    "$ref": "#/components/examples/ServiceCredentialsSecretMetadata"
                  },
                  "UsernamePasswordMetadata": {
                    "$ref": "#/components/examples/UsernamePasswordMetadata"
                  },
                  "CustomCredentialsSecretMetadata": {
                    "$ref": "#/components/examples/CustomCredentialsSecretMetadata"
                  }
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "402": {
            "$ref": "#/components/responses/PaymentRequired"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/NotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          },
          "502": {
            "$ref": "#/components/responses/BadGatewayError"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailableError"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET --location --header \"Authorization: Bearer ${iam_token}\" \\\n",
                      "  --header \"Accept: application/json\" \\\n",
                      "  \"/api/v2/secrets/secretIdForGetSecretLink/metadata\""
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "GetSecretMetadataOptions getSecretMetadataOptions = new GetSecretMetadataOptions.Builder()\n",
                      "  .id(secretIdForGetSecretLink)\n",
                      "  .build();\n",
                      "\n",
                      "Response<SecretMetadata> response = secretsManagerService.getSecretMetadata(getSecretMetadataOptions).execute();\n",
                      "SecretMetadata secretMetadata = response.getResult();\n",
                      "\n",
                      "System.out.println(secretMetadata);"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "const params = {\n",
                      "  id: secretIdForGetSecretLink,\n",
                      "};\n",
                      "\n",
                      "let res;\n",
                      "try {\n",
                      "  res = await secretsManagerService.getSecretMetadata(params);\n",
                      "  console.log(JSON.stringify(res.result, null, 2));\n",
                      "} catch (err) {\n",
                      "  console.warn(err);\n",
                      "}"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "response = secrets_manager_service.get_secret_metadata(\n",
                      "  id=secret_id_for_get_secret_link,\n",
                      ")\n",
                      "secret_metadata = response.get_result()\n",
                      "\n",
                      "print(json.dumps(secret_metadata, indent=2))"
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "getSecretMetadataOptions := secretsManagerService.NewGetSecretMetadataOptions(\n",
                      "  secretIdForGetSecretLink,\n",
                      ")\n",
                      "\n",
[...]
